def project_id     = '50991309'
def project_url    = 'https://gitlab.com/vuthanhtb.dev/my-portfolio.git'
def branch_name    = '*/main'
def commitStatus   = 'build'

def image_name     = 'my-portfolio:latest'

def credential_git  = 'credential_git'

pipeline {
  agent any
  options {
    gitLabConnection('gitlab')
    skipDefaultCheckout(true)
  }
  tools {
    jdk 'jdk17'
  }
  stages {
    stage('1. Checkout') {
      steps {
        gitlabCommitStatus(name: commitStatus, builds: [[projectId: project_id, revisionHash: branch_name]]) {
          cleanWs()
          checkout([
            $class: 'GitSCM',
            branches: [[name: branch_name]],
            extensions: [],
            userRemoteConfigs: [[credentialsId: credential_git, url: project_url]]
          ])
        }
      }
    }
    stage('2. Build SourceCode') {
      steps {
        gitlabCommitStatus(name: commitStatus, builds: [[projectId: project_id, revisionHash: branch_name]]) {
          sh '''docker build -t ''' + image_name + ''' .'''
        }
      }
    }
    stage('3. Deploy') {
      steps {
        gitlabCommitStatus(name: commitStatus,  builds: [[projectId: project_id, revisionHash: branch_name]]) {
          sh '''docker run -d -p 80:80 -name ''' + image_name + ''' ''' + image_name
        }
      }
    }
  }
}
